#include <stdio.h>
#include <stdlib.h>

int T[1600][1600];
int w,h;

void Fill(int i, int j) {
  if (i<0) return;
  if (j<0) return;
  if (i>=h) return;
  if (j>=w) return;
  if (T[i][j]<=0) return;
  T[i][j]=-T[i][j];
//  printf("%d %d %d\n",i,j,T[i][j]);
  Fill(i-1,j);
  Fill(i+1,j);
  Fill(i,j-1);
  Fill(i,j+1);
}

int Bad() {
  int i,j;
  for (i=0;i<h-1;i++)
    for(j=0;j<w-1;j++) {
      if ( (T[i][j]==1)&&(T[i+1][j+1]==1) ) {
        if (T[i+1][j] == 0) return 1;
        if (T[i][j+1] == 0) return 1;
      }
      if ( (T[i+1][j]==1)&&(T[i][j+1]==1) ) {
        if (T[i+1][j+1] == 0) return 1;
        if (T[i][j] == 0) return 1;
      }
    }  
  return 0;
}


int main() {
  int i,j,k;
  char s[10000];
  while(1) {
    scanf("%d %d ",&h,&w);
    if ((w==0)&&(h==0)) break;
    for (i=0;i<h;i++) {
      fgets(s,2000,stdin);
      for (j=0;j<w;j++)
        if (s[j]=='#') T[i][j]=1; else
        T[i][j]=0; 
    }
    if (Bad()) {
      printf("Bad placement.\n");
    } else {
      //    for (i=0;i<h;i++) {
      //      for (j=0;j<w;j++) printf("%d",T[i][j]);
      //      printf("\n");
      //    }
      k=0;  
      for (i=0;i<h;i++) 
        for (j=0;j<w;j++)
          if (T[i][j]>0) {
            Fill(i,j);
            k++;
          }
      printf("There are %d ships.\n",k);
    }
  }
  return 0;          
}
