#include <stdio.h>
#include <stdlib.h>

int T[200][200];
char F[200][200];
int X[1200];
int Y[1200];
int C[1200][4];
int nx,ny,n;

int cmp(int *a, int *b) {
  if (*a<*b) return -1;
  if (*a>*b) return 1;
  return 0;
}

void InsertH(int yy, int x1, int x2) {
  int y,x;
  for (y=0;y<ny;y++) if (Y[y]==yy) break;
  for (x=0;x<nx;x++) if (X[x]==x1) break;
  for (;x<nx;x++) {
    if (X[x]==x2) break;
    T[x][y]=4;
    T[x][y+1]=1;
  }
}

void InsertV(int xx, int y1, int y2) {
  int y,x;
  for (x=0;x<nx;x++) if (X[x]==xx) break;
  for (y=0;y<ny;y++) if (Y[y]==y1) break;
  for (;y<ny;y++) {
    if (Y[y]==y2) break;
    T[x][y]=2;
    T[x+1][y]=8;
  }
}

void Fill(int x, int y) {

  if (x<0) return;
  if (y<0) return;
  if (x>=nx) return;
  if (y>=ny) return;
  if (F[x][y]) return;
  F[x][y]=1;
  if (T[x][y] & 1) Fill(x,y-1);
  if (T[x][y] & 2) Fill(x+1,y);
  if (T[x][y] & 4) Fill(x,y+1);
  if (T[x][y] & 8) Fill(x-1,y);
}

void Fill2(int x, int y) {

  if (x<0) return;
  if (y<0) return;
  if (x>=nx) return;
  if (y>=ny) return;
  if (F[x][y]) return;
  F[x][y]=1;
  Fill(x,y-1);
  Fill(x+1,y);
  Fill(x,y+1);
  Fill(x-1,y);
}

int main() {
  int i,j,k;
  while(1) {
    scanf("%d ",&n);
    if (n==0) break;

    for (i=0;i<n;i++) scanf("%d %d %d %d ",&C[i][0],&C[i][1],&C[i][2],&C[i][3]);
    nx=0;
    for (i=0;i<n;i++)  {
      X[nx++]=C[i][0];
      X[nx++]=C[i][2];
      Y[ny++]=C[i][1];
      Y[ny++]=C[i][3];
    }
    Y[ny++]=-100000;
    Y[ny++]=100000;
    X[nx++]=-100000;
    X[nx++]=100000;
    qsort(X,nx,sizeof(int),cmp);
    qsort(Y,ny,sizeof(int),cmp);
    for (i=1,nx=0;i<2*n+2;i++) {
      if (X[nx]==X[i]) {
      } else {
        X[nx++]=X[i];
      }
    }
    for (i=1,ny=0;i<2*n+2;i++) {
      if (Y[ny]==Y[i]) {
      } else {
        Y[ny++]=Y[i];
      }
    }
    memset(T,0,sizeof(T));
    for (i=0;i<n;i++) {
      if (C[i][0]==C[i][2]) InsertV(C[i][0],C[i][1],C[i][3]);
      if (C[i][1]==C[i][3]) InsertH(C[i][1],C[i][0],C[i][2]);
    }
    memset(F,0,sizeof(F));
    Fill(0,0);
    k=0;
    for (i=0;i<nx;i++)
      for (i=0;i<nx;i++) 
        if (F[i][j]==0) {
          k++;
          Fill2(i,j);
        }
    printf("There are %d holes.\n",k);
  }
  return 0;
}
